this.name = "feudal-promotion.js";
this.author = "Ramirez";
this.copyright = "October 2012";
this.description = "World script for handling a player's feudal rank and promotions";
this.version = "6.0";


// Event handlers

this.shipDockedWithStation = function()

{	
	this.missionScreens()
}


this.guiScreenChanged = function()

{	if(guiScreen == "GUI_SCREEN_MISSION")  
	this.missionScreens()
}

// Mission Screens	

this.missionScreens = function()
{

if(guiScreen == "GUI_SCREEN_MISSION" || !player.ship.docked) return;

if(player.ship.dockedStation.hasRole("planetFall_feudalStates"))
{				
			

if(missionVariables.feudal_promotion_jumpcount == null)

{	if(!missionVariables.feudal_player_rank_no && missionVariables.feudal_score > 4)		
	{	
		mission.runScreen({messageKey: "feudal_knight_promotion", background: "redeagle.png", choicesKey: "feudal_rank_choices"}, this.choiceEvaluation)
		missionVariables.feudal_promotion_offer = "KNIGHT_OFFERED"}
	
	
	if(missionVariables.feudal_mission_home_galaxy !== galaxyNumber && missionVariables.feudal_player_rank_no >= 1)
	{
		mission.runScreen({messageKey: "feudal_promotion_transfer", background: "redeagle.png", choicesKey: "feudal_transfer_choices"}, this.choiceEvaluation)
		missionVariables.feudal_promotion_offer = "TRANSFER_OFFERED"}

}

if(missionVariables.feudal_player_rank_no == 1 && missionVariables.feudal_score > 39)

		{
		++missionVariables.feudal_player_rank_no
		this.defineGeneratorInputs()
		player.feudalRankGenerator()
		this.defineGeneratorOutputs()
		missionVariables.feudal_promotion_date = clock.clockString
		mission.runScreen({messageKey: "feudal_baron_promotion", background: "redeagle.png"})
		mission.setInstructionsKey("feudal_rank_details")
		missionVariables.feudal_promotion_jumpcount = null
		}
		
if(missionVariables.feudal_player_rank_no == 2 && missionVariables.feudal_score > 99)

		{
		++missionVariables.feudal_player_rank_no
		this.defineGeneratorInputs()
		player.feudalRankGenerator()
		this.defineGeneratorOutputs()
		missionVariables.feudal_promotion_date = clock.clockString
		mission.runScreen({messageKey: "feudal_further_promotion", background: "redeagle.png"})
		mission.setInstructionsKey("feudal_rank_details")
		missionVariables.feudal_promotion_jumpcount = null
		}
		
if(missionVariables.feudal_player_rank_no == 3 && missionVariables.feudal_score > 179)

		{
		++missionVariables.feudal_player_rank_no
		this.defineGeneratorInputs()
		player.feudalRankGenerator()
		this.defineGeneratorOutputs()
		missionVariables.feudal_promotion_date = clock.clockString
		mission.runScreen({messageKey: "feudal_further_promotion", background: "redeagle.png"})
		mission.setInstructionsKey("feudal_rank_details")
		missionVariables.feudal_promotion_jumpcount = null
		}
		
if(missionVariables.feudal_player_rank_no == 4 && missionVariables.feudal_score > 279)
		{
		++missionVariables.feudal_player_rank_no
		this.defineGeneratorInputs()
		player.feudalRankGenerator()
		this.defineGeneratorOutputs()
		missionVariables.feudal_promotion_date = clock.clockString
		mission.runScreen({messageKey: "feudal_further_promotion", background: "redeagle.png"})
		mission.setInstructionsKey("feudal_rank_details")
		missionVariables.feudal_promotion_jumpcount = null
		}	
		
		
if(missionVariables.feudal_player_rank_no == 5 && missionVariables.feudal_score > 399)
		{
		++missionVariables.feudal_player_rank_no
		this.defineGeneratorInputs()
		player.feudalRankGenerator()
		this.defineGeneratorOutputs()
		missionVariables.feudal_promotion_date = clock.clockString
		mission.runScreen({messageKey: "feudal_duke_promotion", background: "redeagle.png"})
		mission.setInstructionsKey("feudal_rank_details")
		missionVariables.feudal_promotion_jumpcount = null
		}	
}
}
// Choice evaluations

this.choiceEvaluation = function(choice)
	{
		if(missionVariables.feudal_promotion_offer == "KNIGHT_OFFERED")
			
				
			{	if(choice == "accept_rank_male")	
						{		
							missionVariables.feudal_promotion_offer = null
							missionVariables.feudal_mission_home = system.name
							missionVariables.feudal_mission_home_galaxy = galaxyNumber
							missionVariables.feudal_player_rank_no = 1
							missionVariables.feudal_player_rank = "Knight"
							missionVariables.feudal_player_title = "Sir"
							missionVariables.feudal_player_title_peer = "Lord"
							missionVariables.feudal_player_of = "of"
							missionVariables.feudal_player_gender = "he"
							mission.runScreen({messageKey: "feudal_promotion_knightaccept", background: "redeagle.png"})
							mission.setInstructionsKey("feudal_rank_details")
							missionVariables.feudal_tournament_jumpcount = 0
							}
				if(choice == "accept_rank_female")
						{	missionVariables.feudal_promotion_offer = null
							missionVariables.feudal_mission_home = system.name
							missionVariables.feudal_mission_home_galaxy = galaxyNumber
							missionVariables.feudal_player_rank_no = 1
							missionVariables.feudal_player_title = "Lady"
							missionVariables.feudal_player_title_peer = "Lady"
							missionVariables.feudal_player_rank = "Knight"
							missionVariables.feudal_player_of = "of"
							missionVariables.feudal_player_gender = "she"
							mission.runScreen({messageKey: "feudal_promotion_knightaccept", background: "redeagle.png"})
							mission.setInstructionsKey("feudal_rank_details")
							missionVariables.feudal_tournament_jumpcount = 0
						}	
				if(choice == "decline_rank")
						{	missionVariables.feudal_promotion_offer = null
							mission.runScreen({messageKey: "feudal_promotion_knightdecline", background: "redeagle.png"})
							}	
			}
		
		if(missionVariables.feudal_promotion_offer == "TRANSFER_OFFERED")
		
				if(choice == "accept_transfer")	
						{		
							
							missionVariables.feudal_promotion_offer = null
							missionVariables.feudal_mission_home = system.name
							missionVariables.feudal_mission_home_galaxy = galaxyNumber
							
							if(missionVariables.feudal_player_rank_no == 1)
							{	
								mission.runScreen({messageKey: "feudal_accept_knight_transfer", background: "redeagle.png"})
								mission.setInstructionsKey("feudal_rank_details")	
							}
							
							if(missionVariables.feudal_player_rank_no > 1)
							{
								this.defineGeneratorInputs()
								player.feudalRankGenerator()
								this.defineGeneratorOutputs()
								mission.runScreen({messageKey: "feudal_accept_transfer", background: "redeagle.png"})
							}
							
							mission.setInstructionsKey("feudal_rank_details")
							missionVariables.feudal_tournament_jumpcount = null
						}
				if(choice == "decline_transfer")	
						{	missionVariables.feudal_promotion_offer = null
							mission.runScreen({messageKey: "feudal_promotion_knightdecline", background: "redeagle.png"})		
							missionVariables.feudal_promotion_jumpcount = 0}	
		
	}
		
// Supporting functions

this.defineGeneratorInputs = function()
{
	player.rankGenerator_gender = missionVariables.feudal_player_gender
	player.rankGenerator_house = missionVariables.feudal_mission_home
	player.rankGenerator_level = missionVariables.feudal_player_rank_no
}

this.defineGeneratorOutputs = function()
{	
	missionVariables.feudal_player_of = player.rankGenerator_of
	missionVariables.feudal_player_rank = player.rankGenerator_feudal_specific_rank	
}


	
this.shipWillExitWitchspace = function()
{	
	if(missionVariables.feudal_promotion_jumpcount != null)
	missionVariables.feudal_promotion_jumpcount = null
}
