this.name = "feudal-mission.js";
this.author = "Ramirez";
this.copyright = "December 2011";
this.description = "World script for setting up feudal missions";
this.version = "9.0";



this.startUp = function()
{
this.thePlayerShip = player.ship
}

this.missionScreenEnded = function()
{
	if(!player.ship.docked) return;
	
	this.feudalMissionScreens	
}

this.shipDockedWithStation = function()

{
	if(!player.ship.docked) return;
	this.feudalMissionScreens()	
}

this.guiScreenChanged = function()

{	if(guiScreen == "GUI_SCREEN_MARKET")
	this.feudalMissionScreens()
}

this.resetMissionVariables = function()
{missionVariables.feudal_mission_location_no = null
missionVariables.feudal_mission_location_name = null
missionVariables.feudal_mission_commodity = null
missionVariables.feudal_mission_reward = null
missionVariables.feudal_mission_house = null
missionVariables.feudal_mission_gender = null
missionVariables.feudal_mission_role = null
missionVariables.feudal_mission_ship = null
}

this.defineMissionLocationNo = function() // Define system number for missions if required, based on selected house

	{missionVariables.feudal_mission_location_no = System.systemIDForName([missionVariables.feudal_mission_house])}

this.defineMissionHouse = function() // Randomly select a House related to the mission; reject any where house equals current location
	
	{missionVariables.feudal_mission_house = expandDescription("[feudal_house_"+[galaxyNumber]+"]")
		
		if(missionVariables.feudal_mission_house == system.name)
			{this.defineMissionHouse()}
			else return}

this.defineMissionLocation = function() // Define system name for missions if required, based on system number
	{missionVariables.feudal_mission_location = System.systemNameForID([missionVariables.feudal_mission_location_no])}

this.defineMissionCommodity = function() // Define any commodities associated with the mission
	{missionVariables.feudal_mission_commodity = expandDescription("[feudal_commodity]")}
		
this.defineMissionHome = function() // Defines the home for any feudal missions and ultimately the player's feudal rank
	{missionVariables.feudal_mission_home = system.name}


this.defineFeudalDelivery = function() // Defines all variables needed for a feudal delivery mission
{	this.defineMissionHouse()
	this.defineMissionLocationNo()
	this.defineMissionHome()
	this.defineMissionCommodity()
	missionVariables.feudal_mission_reward = 1000 + (Math.floor(Math.random()*10))*101	
}


this.feudalTributeOffer = function()
{	
	this.defineFeudalTribute()
	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_tribute", music: "feudal-music.ogg", background: "redeagle.png", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);
	missionVariables.feudal_mission_offer = "TRIBUTE_OFFER"
}

this.defineFeudalTribute = function()
{	this.defineMissionHome()
	missionVariables.feudal_mission_reward = 300 + (Math.floor(Math.random()*10))*101	
	missionVariables.feudal_mission_location_no = (Math.floor(Math.random()*256));
	
	if(System.infoForSystem(galaxyNumber,[missionVariables.feudal_mission_location_no]).government == 1 && System.infoForSystem(galaxyNumber,[missionVariables.feudal_mission_location_no]).techlevel < 5)
	{missionVariables.feudal_mission_location_name = System.infoForSystem(galaxyNumber,[missionVariables.feudal_mission_location_no]).name}	
	else
	this.defineFeudalTribute()	
}

this.feudalTributeChoice = function()   

{	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_accepted"})
	missionVariables.feudal_mission = "TRIBUTE_RUNNING"
	mission.setInstructionsKey("feudal_mission_tribute_instructions")
	mission.markSystem([missionVariables.feudal_mission_location_no])
}

this.defineFeudalRansom = function()
{		
	this.defineMissionGender()
	this.defineMissionHouse()
	this.defineGeneratorInputs()
	player.rankGenerator_level = 3
	player.feudalRankGenerator()
	this.defineGeneratorOutputs()
	missionVariables.feudal_mission_rank = player.rankGenerator_feudal_high_rank
	this.defineMissionLocationNo()
	this.defineMissionHome()
	missionVariables.feudal_mission_reward = (Math.floor(Math.random()*4))*3050 + 5000	
}

this.feudalRansomOffer = function()
{	
	this.defineFeudalRansom()
	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_ransom", music: "feudal-music.ogg", background: "redeagle.png", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);
	missionVariables.feudal_mission_offer = "RANSOM_OFFER"
}
		
this.feudalRansomChoice = function()

{	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_accepted"})
	missionVariables.feudal_mission = "RANSOM_RUNNING"
	mission.setInstructionsKey("feudal_mission_ransom_instructions")
	mission.markSystem([missionVariables.feudal_mission_location_no])
}

this.feudalDeliveryOffer = function ()
{
	this.defineFeudalDelivery()
	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_delivery", background: "redeagle.png", music: "feudal-music.ogg", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);
	//mission.runMissionScreen("feudal_mission_delivery", "redeagle.png", "feudal_mission_choices", null, "feudal-music.ogg")
	missionVariables.feudal_mission_offer = "DELIVERY_OFFER"	
}

this.feudalDeliveryChoice = function ()   

{	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_accepted"})
	missionVariables.feudal_mission = "DELIVERY_RUNNING"
	mission.setInstructionsKey("feudal_mission_delivery_instructions")
	mission.markSystem([missionVariables.feudal_mission_location_no])
}



this.feudalExecutionOffer = function ()
			
{
	this.defineFeudalExecution()
	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_execution", background: "redeagle.png", music: "feudal-music.ogg", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);
	//mission.runMissionScreen("feudal_mission_execution", "redeagle.png", "feudal_mission_choices", null, "feudal-music.ogg")
	missionVariables.feudal_mission_offer = "EXECUTION_OFFER"	
}
	
this.feudalExecutionChoice = function ()	
{	
	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_accepted"})
	missionVariables.feudal_mission = "EXECUTION_RUNNING"
	mission.setInstructionsKey("feudal_mission_execution_instructions")
	mission.markSystem([missionVariables.feudal_mission_location_no])
}	
	
this.feudalRaidOffer = function ()
{
	this.defineFeudalRaid()
	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_raid", background: "redeagle.png", music: "feudal-music.ogg", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);
	//mission.runMissionScreen("feudal_mission_raid", "redeagle.png", "feudal_mission_choices", null, "feudal-music.ogg")
	missionVariables.feudal_mission_offer = "RAID_OFFER"
	
}

this.feudalRaidChoice = function ()
{			
	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_accepted"})
	missionVariables.feudal_mission = "RAID_RUNNING"
	mission.setInstructionsKey("feudal_mission_raid_instructions")
	mission.markSystem([missionVariables.feudal_mission_location_no])
	missionVariables.feudal_mission_cargocount = 0
}

this.feudalEscortOffer = function()
{ 
	this.defineFeudalEscort()
	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_escort", background: "redeagle.png", music: "feudal-music.ogg", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);
	missionVariables.feudal_mission_offer = "ESCORT_OFFER"
}

this.feudalEscortChoice = function()	
{	
	mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_accepted"})
	missionVariables.feudal_mission = "ESCORT_RUNNING"
	mission.setInstructionsKey("feudal_mission_escort_instructions")
	mission.markSystem([missionVariables.feudal_mission_location_no])
	missionVariables.feudal_mission_cargocount = 0
	missionVariables.feudal_mission_killcount = 0
}

this.defineFeudalRaid = function()

{
	missionVariables.feudal_mission_location_no = (Math.floor(Math.random()*256));
	missionVariables.feudal_mission_ship = expandDescription("[feudal_freighter]")
	this.defineMissionHouse()
	this.defineMissionLocation()
	this.defineMissionCommodity()
	this.defineMissionHome()
	this.defineMissionRole()
	missionVariables.feudal_mission_reward = 3000 + (Math.floor(Math.random()*10))*97
}


this.defineFeudalExecution = function()
{	
	missionVariables.feudal_mission_location_no = (Math.floor(Math.random()*256));
	missionVariables.feudal_mission_ship = expandDescription("[feudal_fighter]")
	missionVariables.feudal_mission_house = system.name
	this.defineMissionGender()
	this.defineMissionRole()
	player.rankGenerator_level = 2
	this.defineGeneratorInputs()
	player.feudalRankGenerator()
	this.defineGeneratorOutputs()
	this.defineMissionLocation()
	missionVariables.feudal_mission_reward = 8000 + (Math.floor(Math.random()*10))*52
}

this.defineGeneratorInputs = function()
{
	player.rankGenerator_house = missionVariables.feudal_mission_house
	player.rankGenerator_gender = missionVariables.feudal_mission_gender	
}

this.defineGeneratorOutputs = function()
{
	missionVariables.feudal_mission_firstname = player.rankGenerator_feudal_firstname
	missionVariables.feudal_mission_lastname = player.rankGenerator_feudal_lastname
	missionVariables.feudal_mission_of = player.rankGenerator_of
}

this.defineFeudalEscort = function()
{	missionVariables.feudal_mission_location_no = (Math.floor(Math.random()*256));
	missionVariables.feudal_mission_ship = expandDescription("[feudal_freighter]")
	this.defineMissionLocation()
	this.defineMissionHouse()
	this.defineMissionRole()
	this.defineMissionCommodity()
	this.defineMissionHome()
	missionVariables.feudal_mission_reward = 8000 + (Math.floor(Math.random()*10))*48
}

this.defineMissionGender = function() // define gender and basic ranks for mission target

	{	missionVariables.feudal_mission_gender = expandDescription("[feudal_gender]")
		  
		if(missionVariables.feudal_mission_gender == "he")
		{	
			missionVariables.feudal_mission_level1_title = "Sir"
			missionVariables.feudal_mission_level2_title = "Lord"
		}									       
		
		if(missionVariables.feudal_mission_gender == "she")
		
		{	
			missionVariables.feudal_mission_level1_title = "Lady"
			missionVariables.feudal_mission_level2_title = "Lady"	
		}
	}
	
//   define the necessary ship role based on the ship name that has been selected by mission variables

this.defineMissionRole = function()

{	
		if(missionVariables.feudal_mission_ship == "Python Cruiser")
		missionVariables.feudal_mission_role = "feudal-python"
		
		if(missionVariables.feudal_mission_ship == "Anaconda Freighter")
		missionVariables.feudal_mission_role = "feudal-anaconda"
		
		if(missionVariables.feudal_mission_ship == "Boa")
		missionVariables.feudal_mission_role = "feudal-boa"
		
		if(missionVariables.feudal_mission_ship == "Boa Class Cruiser")
		missionVariables.feudal_mission_role = "feudal-boa2"
		
		if(missionVariables.feudal_mission_ship == "Adder")
		missionVariables.feudal_mission_role = "feudal-adder"
		
		if(missionVariables.feudal_mission_ship == "Moray")
		missionVariables.feudal_mission_role = "feudal-moray"
		
		if(missionVariables.feudal_mission_ship == "Fer-de-Lance")
		missionVariables.feudal_mission_role = "feudal-ferdelance"
		
		if(missionVariables.feudal_mission_ship == "Asp Mark II")
		missionVariables.feudal_mission_role = "feudal-asp"
}


this.feudalMissionScreens = function()

{  	if(guiScreen == "GUI_SCREEN_MISSION" || !player.ship.docked) return;
	if(missionVariables.feudal_mission_offer) return;
	
	if(this.thePlayerShip.dockedStation.hasRole("planetFall_feudalStates"))

		{		
			if(guiScreen == "GUI_SCREEN_MARKET")
			
			{	
				if(!missionVariables.feudal_mission && !missionVariables.feudal_player_rank_no)		 
			
				{	this.feudalTributeOffer()
					missionVariables.feudal_score = 0
					// for new starters, offer a delivery only and initialise score
				}
				
				
				if(missionVariables.feudal_mission == "NONE_SET")
			
				{
					this.feudalMissionProb = (Math.random())
				
					if(!missionVariables.feudal_player_rank_no)
						
						if(this.feudalMissionProb <= 0.5)
						this.feudalDeliveryOffer()
						
						else
						
						this.feudalTributeOffer()
							
					if(missionVariables.feudal_player_rank_no == 1 && missionVariables.feudal_mission_home == system.name) 
							
					{	
						if(this.feudalMissionProb <= 0.4)
						this.feudalRaidOffer()
						
						if(this.feudalMissionProb > 0.4 && this.feudalMissionProb <= 0.7)
						this.feudalDeliveryOffer()						

						if(this.feudalMissionProb > 0.9)
						this.feudalTributeOffer()
					
						if(this.feudalMissionProb > 0.7 && this.feudalMissionProb <= 0.9)
						this.feudalEscortOffer()
						
					}
				
			
					if(missionVariables.feudal_player_rank_no == 2 && missionVariables.feudal_mission_home == system.name)
								
					{
			
					if(this.feudalMissionProb <= 0.65)
					this.feudalRaidOffer()
						
					if(this.feudalMissionProb > 0.65 && this.feudalMissionProb <= 0.8)
					this.feudalEscortOffer()
						
					if(this.feudalMissionProb >= 0.8)
					this.feudalExecutionOffer()
					}
			
		
					if(missionVariables.feudal_player_rank_no == 3 && missionVariables.feudal_mission_home == system.name)		
					{	
					
					if(this.feudalMissionProb <= 0.10)
					this.feudalRaidOffer()
						
					if(this.feudalMissionProb >0.10 && this.feudalMissionProb <= 0.8)
					this.feudalRansomOffer()
						
					if(this.feudalMissionProb >= 0.8)
					this.feudalExecutionOffer()	
					}
			
					if(missionVariables.feudal_player_rank_no >= 4 && missionVariables.feudal_mission_home == system.name)		
				
					{
					if(this.feudalMissionProb <= 0.10)
					this.feudalRaidOffer()
						
					if(this.feudalMissionProb > 0.10 && this.feudalMissionProb <= 0.5)
					this.feudalEscortOffer()
					
					if(this.feudalMissionProb >0.5 && this.feudalMissionProb <= 0.8)
					this.feudalRansomOffer()
						
					if(this.feudalMissionProb >= 0.8 && this.feudalMissionProb < 0.9)
					this.feudalExecutionOffer()
					
					if(this.feudalMissionProb >= 0.9)
					this.feudalDeliveryOffer()
					}
				
				}
		
				if(missionVariables.feudal_mission == "DELIVERY_DECLINED")
					{mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_delivery", background: "redeagle.png",
					music: "feudal-music.ogg", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);	
					missionVariables.feudal_mission_offer = "DELIVERY_OFFER"}
					
				if(missionVariables.feudal_mission == "TRIBUTE_DECLINED")
					{mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_tribute", background: "redeagle.png",
					music: "feudal-music.ogg", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);	
					missionVariables.feudal_mission_offer = "TRIBUTE_OFFER"}
					
				if(missionVariables.feudal_mission == "RANSOM_DECLINED")
					{mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_ransom", background: "redeagle.png",
					music: "feudal-music.ogg", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);		
					missionVariables.feudal_mission_offer = "RANSOM_OFFER"}
					
				if(missionVariables.feudal_mission == "RAID_DECLINED")
					{mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_raid", background: "redeagle.png",
					music: "feudal-music.ogg", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);
					missionVariables.feudal_mission_offer = "RAID_OFFER"}
					
				if(missionVariables.feudal_mission == "EXECUTION_DECLINED")
					{mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_execution", background: "redeagle.png",
					music: "feudal-music.ogg", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);
					missionVariables.feudal_mission_offer = "EXECUTION_OFFER"}
					
				if(missionVariables.feudal_mission == "ESCORT_DECLINED")
					{mission.runScreen({title: "Royal Court", messageKey: "feudal_mission_escort", background: "redeagle.png",
					music: "feudal-music.ogg", choicesKey: "feudal_mission_choices"}, this.choiceEvaluation);
					missionVariables.feudal_mission_offer = "ESCORT_OFFER"}
			
			}
			
		
			
			
			// standard responses for missions returning to the Royal Court without market screen
			
			
		if((missionVariables.feudal_mission == "DELIVERY_RUNNING" && system.ID == [missionVariables.feudal_mission_location_no]))	  
			
				{	mission.runScreen({messageKey:"feudal_mission_deliverysuccess"})
					mission.unmarkSystem([missionVariables.feudal_mission_location_no])
					missionVariables.feudal_score += 2
					missionVariables.feudal_mission = "NONE_SET"
					mission.setInstructionsKey(null)
					player.credits += missionVariables.feudal_mission_reward}
					
							
		if(missionVariables.feudal_mission == "TRIBUTE_COLLECTED" && (missionVariables.feudal_mission_home == system.name)) 	  
			
				{	mission.runScreen({messageKey:"feudal_mission_tributesuccess"})
					mission.unmarkSystem([missionVariables.feudal_mission_location_no])
					missionVariables.feudal_score += 1
					missionVariables.feudal_mission = "NONE_SET"
					player.credits += missionVariables.feudal_mission_reward
					mission.setInstructionsKey(null)}
			
		if(missionVariables.feudal_mission == "RAID_SUCCESS" && (missionVariables.feudal_mission_home == system.name)) 
					
					{	if(missionVariables.feudal_mission_cargocount == 18)
				
						{	player.credits += missionVariables.feudal_mission_reward
							mission.runScreen({messageKey: "feudal_mission_raid_bigsuccess"})
							mission.unmarkSystem([missionVariables.feudal_mission_location_no])
							missionVariables.feudal_mission = "NONE_SET"
							missionVariables.feudal_score += 10
							mission.setInstructionsKey(null)
						}
				
						if(missionVariables.feudal_mission_cargocount < 18 && missionVariables.feudal_mission_cargocount > 6)
						{	missionVariables.feudal_mission_reward = Math.floor(missionVariables.feudal_mission_reward*0.8)				
							player.credits += (missionVariables.feudal_mission_reward)
							mission.runScreen({messageKey: "feudal_mission_raid_success"})
							mission.unmarkSystem([missionVariables.feudal_mission_location_no])
							missionVariables.feudal_mission = "NONE_SET"
							missionVariables.feudal_score += 5
							mission.setInstructionsKey(null)
						}
				
						if(missionVariables.feudal_mission_cargocount <= 6)
						{	mission.runScreen({messageKey: "feudal_mission_raid_smallsuccess"})
							mission.unmarkSystem([missionVariables.feudal_mission_location_no])
							missionVariables.feudal_mission = "NONE_SET"
							missionVariables.feudal_score += 3
							mission.setInstructionsKey(null)
						}
					
						if(missionVariables.feudal_mission_cargocount == 0)
						{	
							mission.runScreen({messageKey: "feudal_mission_raid_fail"})
							mission.unmarkSystem([missionVariables.feudal_mission_location_no])
							missionVariables.feudal_mission = "NONE_SET"
							mission.setInstructionsKey(null)
						}
					}		
		
		if(missionVariables.feudal_mission == "RANSOM_SUCCESS" && (missionVariables.feudal_mission_home == system.name)) 
			
				{	player.credits += missionVariables.feudal_mission_reward
					mission.runScreen({messageKey: "feudal_mission_ransom_success"})
					mission.unmarkSystem([missionVariables.feudal_mission_location_no])
					missionVariables.feudal_mission = "NONE_SET"
					missionVariables.feudal_score += 20
					mission.setInstructionsKey(null)
				}
				
		if(missionVariables.feudal_mission == "RANSOM_FAIL" && (missionVariables.feudal_mission_home == system.name))
			
				{	
					mission.runScreen({messageKey: "feudal_mission_ransom_fail"})
					mission.unmarkSystem([missionVariables.feudal_mission_location_no])
					missionVariables.feudal_mission = "NONE_SET"
					missionVariables.feudal_score -= 15
					mission.setInstructionsKey(null)
				}
			
		}
	
		// Responses that don't end at the Royal Court
		
		
			if((missionVariables.feudal_mission == "TRIBUTE_RUNNING" && system.ID == [missionVariables.feudal_mission_location_no]))	  
			
				{	mission.runScreen({messageKey:"feudal_mission_tributecollected"})
					mission.unmarkSystem([missionVariables.feudal_mission_location_no])
					missionVariables.feudal_mission = "TRIBUTE_COLLECTED"}



			if(missionVariables.feudal_mission == "EXECUTION_SUCCESS")		
			
				{	mission.runScreen({messageKey: "feudal_mission_executionsuccess"})
					mission.unmarkSystem([missionVariables.feudal_mission_location_no])
					missionVariables.feudal_mission = "NONE_SET"
					missionVariables.feudal_score += 20
					mission.setInstructionsKey(null)
					player.credits += missionVariables.feudal_mission_reward
				}
				
			if(missionVariables.feudal_mission == "EXECUTION_PARTIALSUCCESS")		
			
				{	missionVariables.feudal_mission_reward = Math.floor(missionVariables.feudal_mission_reward*0.4)
					mission.runScreen({messageKey: "feudal_mission_executionpartialsuccess"})
					mission.unmarkSystem([missionVariables.feudal_mission_location_no])
					player.credits += missionVariables.feudal_mission_reward
					missionVariables.feudal_mission = "NONE_SET"
					missionVariables.feudal_score += 10
					mission.setInstructionsKey(null)
				}
			
			if(missionVariables.feudal_mission == "ESCORT_SUCCESS" && system.ID == [missionVariables.feudal_mission_location_no])
			
				{	player.credits += missionVariables.feudal_mission_reward
					mission.runScreen({messageKey:"feudal_mission_escort_success"})
					mission.unmarkSystem([missionVariables.feudal_mission_location_no])
					missionVariables.feudal_mission = "NONE_SET"
					missionVariables.feudal_score += 20
					mission.setInstructionsKey(null)
				}
				
			if(missionVariables.feudal_mission == "ESCORT_FAIL" && system.ID == [missionVariables.feudal_mission_location_no])
			
				{	if(missionVariables.feudal_mission_cargocount >=12)
			
					{	missionVariables.feudal_mission_reward = Math.floor(missionVariables.feudal_mission_reward*0.75)
						player.credits += missionVariables.feudal_mission_reward
						mission.runScreen({messageKey:"feudal_mission_escort_partialsuccess"})
						mission.unmarkSystem([missionVariables.feudal_mission_location_no])
						missionVariables.feudal_mission = "NONE_SET"
						missionVariables.feudal_score += 10
						mission.setInstructionsKey(null)	
					}
					
					if(missionVariables.feudal_mission_cargocount >= 6 && missionVariables.feudal_mission_cargocount < 12) 
			
					{	missionVariables.feudal_mission_reward = Math.floor(missionVariables.feudal_mission_reward*0.5)	
						mission.unmarkSystem([missionVariables.feudal_mission_location_no])
						player.credits += missionVariables.feudal_mission_reward
						mission.runScreen({messageKey:"feudal_mission_escort_partialsuccess"})
						missionVariables.feudal_mission = "NONE_SET"
						missionVariables.feudal_score += 5
						mission.setInstructionsKey(null)
					}
						
					if(missionVariables.feudal_mission_cargocount < 6)
			
					{	mission.runScreen({messageKey:"feudal_mission_escort_fail"})
						mission.unmarkSystem([missionVariables.feudal_mission_location_no])
						missionVariables.feudal_mission = "NONE_SET"
						missionVariables.feudal_score -= 10
						mission.setInstructionsKey(null)
					}
				
		}
	}
		

this.choiceEvaluation = function(choice)

	{
		
			if(missionVariables.feudal_mission_offer == "DELIVERY_OFFER")
			 
			 
				{	if(choice == "accept_mission")
					
					{this.feudalDeliveryChoice()
					missionVariables.feudal_mission_offer = null}
			
					if(choice == "decline_mission")
					{missionVariables.feudal_mission = "DELIVERY_DECLINED"
					missionVariables.feudal_mission_offer = null}
				}
			
			if(missionVariables.feudal_mission_offer == "TRIBUTE_OFFER")
			 
			 
				{	if(choice == "accept_mission")
					
					{this.feudalTributeChoice()
					missionVariables.feudal_mission_offer = null}
			
					if(choice == "decline_mission")
					{missionVariables.feudal_mission = "TRIBUTE_DECLINED"
					missionVariables.feudal_mission_offer = null}
				}
				
			if(missionVariables.feudal_mission_offer == "EXECUTION_OFFER")	
			
				{ 	if(choice == "accept_mission")	// acceptance for an execution mission
					{this.feudalExecutionChoice()
					missionVariables.feudal_mission_offer = null}
				
					if(choice == "decline_mission")
					{missionVariables.feudal_mission = "EXECUTION_DECLINED"
					missionVariables.feudal_mission_offer = null
					}
				}
				
			if(missionVariables.feudal_mission_offer == "RAID_OFFER")
				{	
				if(choice == "accept_mission")
				
					{this.feudalRaidChoice()
					missionVariables.feudal_mission_offer = null}
						
				if(choice == "decline_mission")
					{missionVariables.feudal_mission = "RAID_DECLINED"
					missionVariables.feudal_mission_offer = null}
				}
			
			if(missionVariables.feudal_mission_offer == "ESCORT_OFFER")	
			
				{ 	if(choice == "accept_mission")
					{this.feudalEscortChoice()
					missionVariables.feudal_mission_offer = null}
				
					if(choice == "decline_mission")
					{missionVariables.feudal_mission = "ESCORT_DECLINED"
					missionVariables.feudal_mission_offer = null}
				}
				
			if(missionVariables.feudal_mission_offer == "RANSOM_OFFER")	
			
				{ 	if(choice == "accept_mission")
					{this.feudalRansomChoice()
					missionVariables.feudal_mission_offer = null}
				
					if(choice == "decline_mission")
					{missionVariables.feudal_mission = "RANSOM_DECLINED"
					missionVariables.feudal_mission_offer = null}		
				}
	}

// ship appearance on launching
	
this.shipWillLaunchFromStation = function()

{if(missionVariables.feudal_mission_offer)
missionVariables.feudal_mission_offer = null}

// witchspace exit conditions

this.shipExitedWitchspace = function()
{	
			
	if(missionVariables.feudal_mission == "DELIVERY_RUNNING")
	
		{	if(Math.random() <= 0.25)
			system.legacy_addSystemShips("pirate", 4, 0.1)}
	
	if(missionVariables.feudal_mission == "RAID_RUNNING" && system.ID == [missionVariables.feudal_mission_location_no])
	
		{	system.legacy_addSystemShips([missionVariables.feudal_mission_role], 3, 0.5) // populate the system with the raid target along with some knights
			system.legacy_addSystemShips([missionVariables.feudal_mission_house]+"-knight", 12, 0.5)}

	if(missionVariables.feudal_mission == "EXECUTION_RUNNING" && system.ID == [missionVariables.feudal_mission_location_no])
	
		system.legacy_addSystemShips([missionVariables.feudal_mission_role], 1, 0.8) // populate the system with the execution target
		
		
	if(missionVariables.feudal_mission == "ESCORT_RUNNING" && system.ID == [missionVariables.feudal_mission_location_no])
		{	system.legacy_addSystemShips([missionVariables.feudal_mission_role], 3, 0.6) // populate the system with the freighter to be escorted
			system.legacy_addSystemShips([missionVariables.feudal_mission_home]+"-knight", 12, 0.6) // add some knights from the home side to support the freighter
			system.legacy_addSystemShips([missionVariables.feudal_mission_house]+"-knight", 7, 0.8) // add some knights from enemy side
			system.legacy_addSystemShips([missionVariables.feudal_mission_house]+"-lord", 1, 0.8) // add some lords from the enemy side
		}
		
	if(missionVariables.feudal_mission == "RANSOM_RUNNING" && system.ID == [missionVariables.feudal_mission_location_no])

		{system.legacy_addShipsAtPrecisely([missionVariables.feudal_mission_house]+"-prince", 1, "wsm", [0, 115000, 0])// add the ransom target
		
		}				
						
	
	if(missionVariables.feudal_mission)
	{if(missionVariables.feudal_mission.indexOf("DECLINED") > 1)
	{missionVariables.feudal_mission = "NONE_SET"
	mission.setInstructionsKey(null)
	this.resetMissionVariables()}}
}


this.playerEnteredNewGalaxy = function()
{	missionVariables.feudal_mission = "NONE_SET"
	mission.setInstructionsKey(null)
	this.resetMissionVariables()
	
}

