this.name = "feudal-target.js";
this.author = "Ramirez";
this.copyright = "March 2013";
this.description = "Ship script for targets of feudal missions and challenges; checks roles, sets IDs, AIs and death actions as appropriate";
this.version = "1.6";


this.zeroEscorts = function()
{ 


if(this.ship.escorts.length > 0)
   {   
	  this.ship.escorts[0].remove();
	  //log('escort removed')
   }
   
if(this.ship.escorts.length == 0)
   {this.zETimer.stop()
   //log('timer stopped')
}
} 

this.shipSpawned = function ()// set up IDs and AIs for targets
{

	if(missionVariables.feudal_mission == "NONE_SET")
 		{this.zETimer = new Timer(this,this.zeroEscorts,null,0.2);} 

      if(missionVariables.feudal_mission == "EXECUTION_RUNNING" && this.ship.primaryRole == [missionVariables.feudal_mission_role])
	
		{	if(this.ship.displayName == this.ship.name)
			this.ship.displayName = expandDescription("[mission_feudal_mission_level1_title] [mission_feudal_mission_firstname] [mission_feudal_mission_lastname]") // Show the ID of the execution target
		}
			//also in future set an AI specific to the EXECUTION mission
		
	if(missionVariables.feudal_mission == "RANSOM_RUNNING")
	
         {	if(this.ship.primaryRole == [missionVariables.feudal_mission_house]+"-prince")
			{
			   {this.zETimer = new Timer(this,this.zeroEscorts,null,0.2);} 
					
			   if(this.ship.displayName == this.ship.name)
				  {this.ship.displayName = expandDescription("[mission_feudal_mission_rank] [mission_feudal_mission_of] [mission_feudal_mission_house]")}
			   }
                                
            if(this.ship.primaryRole == [missionVariables.feudal_mission_house]+"-knight")
                  { this.ship.switchAI("feudal-escortAI.plist") }
               }

	if(missionVariables.feudal_mission == "RAID_RUNNING")
	
	  {  if(this.ship.primaryRole == missionVariables.feudal_mission_role) 
			{
			   this.zETimer = new Timer(this,this.zeroEscorts,null,0.2)
                
			   if(this.ship.displayName == this.ship.name) 
						{   this.ship.displayName = expandDescription("[mission_feudal_mission_house] [mission_feudal_mission_commodity] convoy")} // Show the ID of the raid target 			    
                        }
                  if(this.ship.primaryRole == [missionVariables.feudal_mission_house]+"-knight")
				  {this.ship.switchAI("feudal-escortAI.plist")}
	  }
	
	 if(missionVariables.feudal_mission == "ESCORT_RUNNING")
	
		{	if(this.ship.primaryRole == missionVariables.feudal_mission_role)
				{
					{this.zETimer=new Timer(this,this.zeroEscorts,null,0.2);} 
					
					if(this.ship.displayName == this.ship.name)
						{	this.ship.displayName = expandDescription("[mission_feudal_mission_home] [mission_feudal_mission_commodity] convoy")} // Show the ID of the freighter to be escorted			
				}	
	
		
			if(this.ship.primaryRole == [missionVariables.feudal_mission_home]+"-knight") // home knights to protect escort
			{     this.ship.switchAI("feudal-escortAI.plist")
                     if(this.ship.displayName == this.ship.name)
						{	this.ship.displayName = expandDescription("[mission_feudal_mission_home] Knight (friendly)") // Show the ID of the friendly knight	
						}
                        }
                       		
			if(this.ship.primaryRole == [missionVariables.feudal_mission_house]+"-knight") // enemy knights to find and attack escort
			{     this.ship.switchAI("feudal-raidAI.plist")
                        
                     if(this.ship.displayName == this.ship.name)
						{	this.ship.displayName = expandDescription("[mission_feudal_mission_house] Knight (enemy)")} // Show the ID of the enemy knight			
            }
					
			
			if(this.ship.primaryRole == [missionVariables.feudal_mission_house]+"-lord") // enemy lords to attack escort
			{     this.ship.switchAI("feudal-raidAI.plist")
                  if(this.ship.displayName == this.ship.name)
						{	this.ship.displayName = expandDescription("[mission_feudal_mission_house] Lord (enemy)")} // Show the ID of the enemy lord		
            }
				
		}
         
         if(missionVariables.feudal_challenger == "RUNNING" && this.ship.primaryRole == [missionVariables.feudal_challenger_role])
	
		 {	if(this.ship.displayName == this.ship.name)
			
            {this.ship.awardEquipment("EQ_MISSILE_REMOVAL")
			this.zETimer=new Timer(this,this.zeroEscorts,null,0.2);

            if(missionVariables.feudal_challenger_rank_no == 1)
               {this.ship.switchAI("feudal-challenger1AI.plist")
               this.ship.displayName = expandDescription("[mission_feudal_challenger_title] [mission_feudal_challenger_firstname] [mission_feudal_challenger_lastname]")}         
               else
               {this.ship.displayName = expandDescription("[mission_feudal_challenger_rank] [mission_feudal_challenger_of] [mission_feudal_challenger_house]")
			   this.ship.switchAI("feudal-challenger2AI.plist")}
            }     
         }
                
         if(missionVariables.feudal_tournament == "EVENT3_RUNNING")
         
         {if(this.ship.primaryRole == "feudal-knight" || "feudal-lord" || "feudal-prince")
             {this.ship.switchAI("feudal-quartetAI.plist")
             this.ship.fuel = 0	  
             {this.zETimer = new Timer(this,this.zeroEscorts,null,0.2);}       
             }
           if(this.ship.primaryRole == "feudal-drone")
             this.ship.switchAI("pirateAI.plist")
         }
           if(missionVariables.feudal_tournament == "EVENT5_RUNNING")
         {   this.ship.switchAI("feudal-meleeAI.plist")
		     {this.zETimer=new Timer(this,this.zeroEscorts,null,0.2);}
             }        
         
         if(missionVariables.feudal_tournament == "EVENT6_RUNNING")
         {  this.ship.switchAI("feudal-challenger2AI.plist")
			{this.zETimer=new Timer(this,this.zeroEscorts,null,0.2);}
            this.ship.fuel = 100
            this.ship.displayName = expandDescription("[mission_feudal_tournament_opponent_text]")
         }        
}

this.shipDied = function(whom)

{      
         
               if(missionVariables.feudal_tournament == "EVENT1_RUNNING") 
               {if(this.ship.primaryRole == "feudal-shield")
               {var buoy = system.shipsWithRole("feudal-buoy")[0]
               this.ship.target = buoy
               this.ship.target.switchAI("feudal-buoy-checkAI.plist")}
               }         
         
               if(missionVariables.feudal_tournament == "EVENT2_RUNNING")
               {++missionVariables.feudal_tournament_kills
               player.commsMessage("Stage "+ [missionVariables.feudal_tournament_kills]+" destroyed.")
            
               {  if (this.ship.primaryRole == "feudal-drone-1")
                        this.ship.spawn("feudal-drone-2", 1)
               
                  if (this.ship.primaryRole == "feudal-drone-2")
                        this.ship.spawn("feudal-drone-3", 1)

                  if (this.ship.primaryRole == "feudal-drone-3")
                        this.ship.spawn("feudal-drone-4", 1)

                  if (this.ship.primaryRole == "feudal-drone-4")
                        this.ship.spawn("feudal-drone-5", 1)
               }
               }
               
               if(missionVariables.feudal_tournament == "EVENT4_RUNNING")
                     if(this.ship.primaryRole == "feudal-shield-pod")
                     this.ship.spawn("feudal-small-shield", 1)   
               
               if(missionVariables.feudal_tournament == "EVENT5_RUNNING")
               {               
                  if(this.ship.AI == "feudal-meleeAI.plist")
                  {--missionVariables.feudal_tournament_ships
               
                     if(missionVariables.feudal_tournament_ships > 2)
                       player.commsMessage(this.ship.name+" destroyed. "+missionVariables.feudal_tournament_ships+" competitors remaining.")
               
                     else   
                  
                  {var buoy = system.shipsWithRole("feudal-buoy")[0]
                  this.ship.target = buoy
                  this.ship.target.switchAI("feudal-buoy-logAI.plist")
                  player.commsMessage(this.ship.name+" destroyed. Two competitors remaining.  Please return to the Hunting Lodge")
                  }
                  
               } 
               }
               
               if(missionVariables.feudal_tournament == "EVENT6_RUNNING")
               ++missionVariables.feudal_tournament_kills
              
               if(missionVariables.feudal_mission == "EXECUTION_RUNNING" && this.ship.primaryRole == [missionVariables.feudal_mission_role])
			   {  if(whom == player.ship)
				  	missionVariables.feudal_mission = "EXECUTION_SUCCESS" // set the mission variable to success
				  	else
				   	missionVariables.feudal_mission = "EXECUTION_PARTIAL" // have a partial success where the player is awarded fewer points
			   }

		 if(missionVariables.feudal_mission == "RAID_RUNNING" || missionVariables.feudal_mission == "RAID_SUCCESS")
		 
		 {
		if(this.ship.primaryRole == missionVariables.feudal_mission_role)	// if it's a raid, get the target ship to spawn some of the selected commodity
		{this.ship.spawn("feudal-cargo", 6)
		missionVariables.feudal_mission = "RAID_SUCCESS"
		mission.setInstructionsKey("feudal_mission_raid_return", "feudal-mission.js")}
		 }

		if(missionVariables.feudal_mission == "RANSOM_RUNNING" && this.ship.primaryRole == [missionVariables.feudal_mission_house]+"-prince")
	
                  {this.ship.spawn("feudal-escape-pod", 1)}
		
	       if(missionVariables.feudal_mission == "ESCORT_RUNNING" && this.ship.primaryRole == missionVariables.feudal_mission_role)	// if it's an escort mission, get the target ship to spawn some of the selected commodity
		{this.ship.spawn("feudal-cargo", 6)
		missionVariables.feudal_mission = "ESCORT_FAIL"
		player.commsMessage("One of the freighters has been destroyed!", 6)}
		
	       if(missionVariables.feudal_mission == "ESCORT_RUNNING" && this.ship.primaryRole == [missionVariables.feudal_mission_house]+"-knight")
                missionVariables.feudal_mission_killcount += 1
                
               if(missionVariables.feudal_mission == "ESCORT_RUNNING" && missionVariables.feudal_mission_killcount == 10)
               {missionVariables.feudal_mission = "ESCORT_SUCCESS"
               player.commsMessage("The enemy knights have been destroyed.  We can take it from here.")}
               
               if(missionVariables.feudal_challenger == "VICTORY")
               {this.ship.spawn("feudal-escape-pod", 1)
               missionVariables.feudal_challenger = "FORFEIT"}
               
                if(missionVariables.feudal_challenger == "RUNNING")
               {this.ship.spawn("feudal-escape-pod", 1)
               missionVariables.feudal_challenger = "VICTORY"}
		
		//award player points if they shoot enemy ships at any time during a mission
		
	       	if(whom == player.ship)
		
			{	if(this.ship.primaryRole == [missionVariables.feudal_mission_house]+"-knight")
					{missionVariables.feudal_score += 1}

				if(this.ship.primaryRole == [missionVariables.feudal_mission_house]+"-lord")
					missionVariables.feudal_score += 5
				
				if(this.ship.primaryRole == [missionVariables.feudal_mission_house]+"-prince")
					{missionVariables.feudal_score += 20}
			}
               }
                

this.shipBeingAttacked = function()

{  if(missionVariables.feudal_tournament == "EVENT5_RUNNING")
      {if(this.ship.energy > 1000)
      this.ship.energy = 500}
}

this.shipEnteredStationAegis = function(station)

	{	if(missionVariables.feudal_mission == "ESCORT_RUNNING" && this.ship.primaryRole == missionVariables.feudal_mission_role)

		{	missionVariables.feudal_mission = "ESCORT_SUCCESS"
			this.ship.commsMessage("Thanks, Commander.  We've made it to the station in one piece.  We can take it from here.", 6) 
		}
		  if((missionVariables.feudal_mission == "ESCORT_RUNNING" || missionVariables.feudal_mission == "ESCORT_SUCCESS") && this.ship.primaryRole == [missionVariables.feudal_mission_house]+"-knight")  
	       {	this.ship.commsMessage("Let's get out of here!", 6) 
			//log('knight entering aegis')
			this.ship.switchAI("route1traderAI.plist")
	       }
	}
        
this.shipEnergyIsLow = function()
   {   if(missionVariables.feudal_challenger == "RUNNING" && this.ship.primaryRole == [missionVariables.feudal_challenger_role])
	{this.ship.spawn("feudal-flare", 1);
      this.ship.commsMessage(expandDescription("[feudal-yield]"))
      this.ship.switchAI("feudal-challengerhomeAI.plist")
      missionVariables.feudal_challenger = "VICTORY"}
      
      if(missionVariables.feudal_tournament == "EVENT5_RUNNING")
         {
            if(this.ship.AI == "feudal-meleeAI.plist")
            {if(Math.random() < 0.25)
            {this.ship.switchAI("feudal-challengerhomeAI.plist")
            --missionVariables.feudal_tournament_ships
            
            if(missionVariables.feudal_tournament_ships > 2)
                  {player.commsMessage(this.ship.name+" surrendered. "+missionVariables.feudal_tournament_ships+" competitors remaining.")
                  this.ship.displayName = this.ship.name+" (Surrendered)"}
               
               else   
                  
                  {var buoy = system.shipsWithRole("feudal-buoy")[0]
                  this.ship.target = buoy
                  this.ship.target.switchAI("feudal-buoy-logAI.plist")
                  this.ship.displayName = this.ship.name+" (Surrendered)"
                  player.commsMessage(this.ship.name+" surrended. Two competitors remaining.  Please return to the Hunting Lodge")
                  }
            }
      }}
   }      
this.shipTargetLost = function()
   {    if(missionVariables.feudal_challenger == "RUNNING")
         this.ship.switchAI("feudal-challengerhomeAI.plist")}

this.checkDistance = function()
{if(player.ship.position.distanceTo(this.ship) < 5000)
   {this.ship.target = player.ship;
   this.ship.reactToAIMessage("FOUND_PLAYER")}
   }

this.shipWasScooped = function (whom)
   { if(this.ship.primaryRole == "feudal-drone" && whom == player.ship )
		
         {  if(missionVariables.feudal_tournament == "EVENT3_RUNNING")
                {++missionVariables.feudal_tournament_scoops
                player.commsMessage("Target drone collected.  Return to the Hunting Lodge.")}                     
         }         
      if(this.ship.primaryRole == "feudal-small-shield" && whom == player.ship )         
         
         {if(missionVariables.feudal_tournament == "EVENT4_RUNNING")
                {++missionVariables.feudal_tournament_scoops
                player.commsMessage("Score: " + [missionVariables.feudal_tournament_scoops] + " out of 10")}                     
                }         
         }
                
            
   
